#!/usr/local/bin/python
"""
fmatrix.py : loading sparse feature matrix.
$Id: fmatrix.py,v 1.3 2018/10/10 04:41:33 daichi Exp $
"""
import numpy as np
import sys

class document:
    def __init__ (self):
        self.id  = []
        self.cnt = []
    def dump (self):
        print ('id  =', self.id)
        print ('cnt =', self.cnt)

def parse (file):
    data = []
    with open (file, 'r') as fh:
        for line in fh:
            tokens = line.split()
            if len(tokens) > 0:
                doc = document()
                for token in tokens:
                    id,cnt = token.split(':')
                    doc.id.append (int(id))
                    doc.cnt.append (int(cnt))
                data.append (doc)
    return data

def plain (file):
    """
    build a plain word sequence for LDA.
    """
    data = []
    with open (file, 'r') as fh:
        for line in fh:
            words = expand (line)
            data.append (words)
    return data

def expand (line):
    words = []
    tokens = line.split()
    if len(tokens) > 0:
        for token in tokens:
            [id,cnt] = token.split(':')
            w = int(id)
            c = int(cnt)
            words.extend ([w for x in range(c)])
        return words
    else:
        return []

def main ():
    data = plain (sys.argv[1])
    print (data)
    
if __name__ == "__main__":
    main ()
    
